//************ Gestion des dates Partie 1 ****************
import 'NE_PAS_TOUCHER/user_input.dart';

class Date {
  int? jour;
  int? mois;
  int? annee;

  Date({this.jour, this.mois, this.annee});

  void userDate() {
    this.jour = readInt('Quel jour ?');
    this.mois = readInt('Quel mois ?');
    this.annee = readInt('Quel année ?');
  }

  String displayDate() {
    if (this.jour! < 10 && this.mois! < 10) {
      return ('0$jour/0$mois/$annee');
    } else if (this.jour! < 10 && this.mois! > 9) {
      return ('0$jour/$mois/$annee');
    } else if (this.jour! > 9 && this.mois! < 10) {
      return ('$jour/0$mois/$annee');
    } else {
      return ('$jour/$mois/$annee');
    }
  }
  void chekDate() {
  do {
    userDate();
    if (this.jour! > obtenirJourMax()) {
      print('Merci de re-saisir la date');
      userDate();
    }
  } while (
      this.jour! < 1 || this.jour! > 31 || this.mois! < 1 || this.mois! > 12);
}

int obtenirJourMax() {
    int jourMax = 31;
    if (this.mois == 4 || this.mois == 6 || this.mois == 9 || this.mois == 11) {
      jourMax = 30;
    } else if (this.mois == 2) {
      if (estBissextile()) {
        jourMax = 29;
      } else {
        jourMax = 28;
      }
    }
    return jourMax;
  }
  
bool estPlusRecentQue(Date date) {
  if (this.annee! > date.annee!) {
    return true;
  } else if (this.annee! == date.annee! && this.mois! > date.mois!) {
    return true;
  } else if (this.annee! == date.annee! &&
      this.mois! == date.mois! &&
      this.jour! > date.jour!) {
    return true;
  } else {
    return false;
  }
}
bool estBissextile() => ((this.annee! % 4 == 0 && this.annee! % 100 != 0) ||
      this.annee! % 400 == 0);

}
