//  Created by Franck CORNU on 24/12/2023.
import 'dart:io';
import 'dart:math';
import 'NE_PAS_TOUCHER/user_input.dart';
import 'xgeo.dart';
import 'rectangle.dart';

void main() {
  /*List<Xgeo> listX = [];
  xGenerator(listX);
  displayX(listX);*/
  Xgeo newX = Xgeo(x: 2, y: 2, width: 11, heigth: 11);
  newX.offsetXAxis(3); // attention c'est de l'offset, si x est initialisé à 2, le nouveau x est 5 !!!
  newX.offsetYAxis(3);
  newX.starX();
  //List<Rectangle> listSq = [];
  //displayMenu(listSq);
}

void drawSq(List list) {
  displaySq(list);
  print('Choisissez un rectangle à dessiner :\n');
  Rectangle rDraw = list.elementAt(readInt('Quel est votre choix ?') - 1);
  rDraw.starPaint();
  print('');
}

void addSq(List list) {
  list.add(Rectangle(width: readInt('Largeur'), heigth: readInt('Hauteur')));
  print(Process.runSync("clear", [], runInShell: true).stdout);
  print(
      '             Vous avez ajouté un nouveau rectangle, la nouvelle liste est : \n');
  displaySq(list);
  print('');
}

void delete(List list) {
  displaySq(list);
  list.removeAt(readInt('Quel carré souhaitez-vous supprimer ?') - 1);
  print(' et Voici la nouvelle liste\n');
  displaySq(list);
  print('');
}

void displaySq(List list) {
  Rectangle rView;
  if (list.length > 0) {
    for (int i = 0; i < list.length; i++) {
      rView = list.elementAt(i);
      print('Rectangle, ${i + 1}, ${rView.width}, ${rView.heigth}');
    }
  }
}

void displayX(List list) {
  Xgeo rView;
  if (list.length > 0) {
    for (int i = 0; i < list.length; i++) {
      rView = list.elementAt(i);
      print(
          'Croix, ${i + 1}, ${rView.x}, ${rView.y}, ${rView.width}, ${rView.heigth}');
    }
  }
}

List sqGenerator(List listSq) {
  for (int i = 1; i < 6; i++) {
    listSq.add(Rectangle(
        width: Random().nextInt(18) + 3, heigth: Random().nextInt(18) + 3));
  }
  return listSq;
}

List xGenerator(List listX) {
  int xW;
  int xH;
  for (int i = 1; i < 6; i++) {
    do {
      xW = Random().nextInt(12) + 3;
      xH = Random().nextInt(12) + 3;
    } while (xW % 2 == 0 || xH % 2 == 0);

    listX.add(Xgeo(width: xW,heigth: xH));
  }
  return listX;
}

void displayMenu(List list) {
  sqGenerator(list);
  print(Process.runSync('clear', [], runInShell: true).stdout);
  int userChoice = 0;
  print('''
  Je vous propose de dessiner un carré avec un format prédéfini, 
                ou en utilisant vos dimensions. \n''');
  do {
    print('''            0 Dessiner               1 Ajouter

            2 Supprimer               3 Quitter

''');
    do {
      userChoice = readInt('                    Quel est votre choix ?');
    } while (userChoice < 0 || userChoice > 3);

    switch (userChoice) {
      case 0:
        drawSq(list);
        break;
      case 1:
        addSq(list);
        break;
      case 2:
        delete(list);
        break;
      case 3:
        print(Process.runSync('clear', [], runInShell: true).stdout);// cette fonction sert à nettoyer l'écran , marche sur Mac.
        print('''                         Au revoir\n'
                      * *         * *
                  *       *     *       * 
                 *          * *          *
                 *           *           *
                 *                       *
                  *                     *
                    *                 *
                      *             *
                         *       * 
                            * *        
                             *      ''');
        break;
      default:
        print('Valeur inconnue');
        break;
    }
  } while (userChoice != 3);
}
