//  Created by Franck CORNU on 24/12/2023.
import 'dart:io';
import 'NE_PAS_TOUCHER/user_input.dart';
import 'xgeo.dart';
import 'rectangle.dart';

void main() {
  List<Rectangle> listRectangle = [];
  Rectangle rec = Rectangle();
  displayMenu(rec.Generator(listRectangle), rec);

  //List<Xgeo> listX = [];
  Xgeo xgeo = Xgeo();
  xgeo.offsetXAxis(4); // attention c'est de l'offset, si x est initialisé à 2, le nouveau x est 5 !!!
  xgeo.offsetYAxis(6);
  xgeo.xPaint();
  //xgeo.display(xgeo.Generator(listX), xgeo);
}

void displayMenu(List list, Rectangle rec) {
  print(Process.runSync('clear', [], runInShell: true).stdout);
  int userChoice = 0;
  print('''
  Je vous propose de dessiner un carré avec un format prédéfini, 
                ou en utilisant vos dimensions. \n''');
  do {
    print('''            0 Dessiner               1 Ajouter

            2 Supprimer               3 Quitter

''');
    do {
      userChoice = readInt('                    Quel est votre choix ?');
    } while (userChoice < 0 || userChoice > 3);

    switch (userChoice) {
      case 0:
        drawRec(list, rec);
        break;
      case 1:
        addRec(list, rec);
        break;
      case 2:
        delete(list, rec);
        break;
      case 3:
        print(Process.runSync('clear', [], runInShell: true)
            .stdout); // cette fonction sert à nettoyer l'écran , marche sur Mac.
        print('''                         Au revoir\n'
                      * *         * *
                  *       *     *       * 
                 *          * *          *
                 *           *           *
                 *                       *
                  *                     *
                    *                 *
                      *             *
                         *       * 
                            * *        
                             *      ''');
        break;
      default:
        print('Valeur inconnue');
        break;
    }
  } while (userChoice != 3);
}

void drawRec(List list, Rectangle rec) {
  rec.display(list, rec);
  print('Choisissez un rectangle à dessiner :\n');
  rec = list.elementAt(readInt('Quel est votre choix ?') - 1);
  rec.starPaint();
  print('');
}

void delete(List list, Rectangle rec) {
  rec.display(list, rec);
  list.removeAt(readInt('Quel carré souhaitez-vous supprimer ?') - 1);
  print(' et Voici la nouvelle liste\n');
  rec.display(list, rec);
  print('');
}

void addRec(List list, Rectangle rec) {
  list.add(Rectangle(width: readInt('Largeur'), heigth: readInt('Hauteur')));
  print(Process.runSync("clear", [], runInShell: true).stdout);
  print(
      '             Vous avez ajouté un nouveau rectangle, la nouvelle liste est : \n');
  rec.display(list, rec);
  print('');
}
