import 'dart:io';
import 'dart:math';
import 'geoForm.dart';

class Rectangle extends Geoform {
  Rectangle({int x = 0, int y = 0, int width = 0, int heigth = 0})
      : super(x: x, y: y, width: width, heigth: heigth);

  void starPaint() {
    //if (this.width > 0 && this.heigth > 0) {
    for (int line = 0; line < this.heigth + y; line++) {
      for (int column = 0; column < this.width + x; column++) {
        if (column < x || line < y) {
          stdout.write('. ');
          
        } else
          stdout.write('* ');
      }

      print('');
    }
  }

  @override
  List Generator(List list) {
    for (int i = 1; i < 6; i++) {
      list.add(Rectangle(
          x: Random().nextInt(5),
          y: Random().nextInt(
            5,
          ),
          width: Random().nextInt(18) + 3,
          heigth: Random().nextInt(18) + 3));
    }
    return list;
  }

  void display(List list, Rectangle rec) {
    if (list.length > 0) {
      for (int i = 0; i < list.length; i++) {
        rec = list.elementAt(i);
        print(
            'Rectangle, ${i + 1}, ${rec.x}, ${rec.y}, ${rec.width}, ${rec.heigth}');
      }
    }
  }
}
/*void starPaint() {
    if (this.width > 0 && this.heigth > 0) {
      for (int line = 0; line < this.heigth; line++) {
        for (int column = 0; column < this.width; column++) {
          if (line == 0 ||
              line == this.heigth - 1 ||
              column == 0 ||
              column == this.width - 1) {
            stdout.write('* ');
          } else {
            stdout.write('  ');
          }
        }
        print('');
      }*/