import 'dart:io';
import 'dart:math';

import 'geoForm.dart';

class Xgeo extends Geoform {
  Xgeo({int x = 0, int y = 0, int width = 11, int heigth = 11})
      : super(x: x, y: y, width: width, heigth: heigth);

  void xPaint() {
    print(Process.runSync('clear', [], runInShell: true).stdout);
    if (width.isEven || heigth.isEven) {
      print(
          'Je ne sais dessiner que des croix impaires, merci d‘entrer une nouvelle valeur');
    } else {
      for (int line = 0; line < y + heigth; line++) {
        for (int column = 0; column < x + width; column++) {
          if (column >= x && line >= y) {
            if (column == (width ~/ 2) + x || line == (heigth ~/ 2) + y) {
              stdout.write("* ");
            } else {
              stdout.write("  ");
            }
          } else {
            stdout.write(". ");
          }
        }
        print('');
      }
    }
  }
@override
  List Generator(List list) {
    int xW;
    int xH;
    for (int i = 1; i < 6; i++) {
      do {
        xW = Random().nextInt(12) + 3;
        xH = Random().nextInt(12) + 3;
      } while (xW % 2 == 0 || xH % 2 == 0);

      list.add(Xgeo(width: xW, heigth: xH));
    }
    return list;
  }

  void display(List list,Xgeo xgeo) {
    if (list.length > 0) {
      for (int i = 0; i < list.length; i++) {
        xgeo = list.elementAt(i);
        print(
            'Croix, ${i + 1}, ${xgeo.x}, ${xgeo.y}, ${xgeo.width}, ${xgeo.heigth}');
      }
    }
  }
}
