//  Created by Franck CORNU on 24/12/2023.
import 'dart:io';
import 'dart:math';
import 'NE_PAS_TOUCHER/user_input.dart';
import 'rectangle.dart';

void main() {
  List<Rectangle> listSize = [];
  displayMenu(listSize);
}

void drawRectangle(List listSize) {
  displayList(listSize);
  print('Choisissez un rectangle à dessiner :\n');
  Rectangle rDraw = listSize.elementAt(readInt('Quel est votre choix ?') - 1);
  rDraw.starPaint();
  print('');
}

void addRectangle(List listSize) {
  listSize
      .add(Rectangle(width: readInt('Largeur'), heigth: readInt('Hauteur')));
  print(Process.runSync("clear", [], runInShell: true).stdout);
  print(
      '             Vous avez ajouté un nouveau rectangle, la nouvelle liste est : \n');
  displayList(listSize);
  print('');
}

void delete(List listSize) {
  displayList(listSize);
  listSize.removeAt(readInt('Quel carré souhaitez-vous supprimer ?') - 1);
  print(' et Voici la nouvelle liste\n');
  displayList(listSize);
  print('');
}

void displayList(List listSize) {
  Rectangle rView;
  if (listSize.length > 0) {
    for (int i = 0; i < listSize.length; i++) {
      rView = listSize.elementAt(i);
      print('Rectangle, ${i + 1}, ${rView.width}, ${rView.heigth}');
    }
  }
}

List listGenerator(List listSize) { // c'est parce que c'est plus facile que de saisir à la main
  for (int i = 1; i < 6; i++) {
    listSize.add(Rectangle(
        width: Random().nextInt(18) + 3, heigth: Random().nextInt(18) + 3));
  }
  return listSize;
}

void displayMenu(List listSize) {
  listGenerator(listSize);
  print(Process.runSync('clear', [], runInShell: true).stdout);
  int userChoice = 0;
  print('''
  Je vous propose de dessiner un carré avec un format prédéfini, 
                ou en utilisant vos dimensions. \n''');
  do {
    print('''            0 Dessiner               1 Ajouter

            2 Supprimer               3 Quitter

''');
    do {
      userChoice = readInt('                    Quel est votre choix ?');
    } while (userChoice < 0 || userChoice > 3);

    switch (userChoice) {
      case 0:
        drawRectangle(listSize);
        break;
      case 1:
        addRectangle(listSize);
        break;
      case 2:
        delete(listSize);
        break;
      case 3:
        print(Process.runSync('clear', [], runInShell: true).stdout);
        print('''                         Au revoir\n'
                      * *         * *
                  *       *     *       * 
                 *          * *          *
                 *           *           *
                 *                       *
                  *                     *
                    *                 *
                      *             *
                         *       * 
                            * *        
                             *      ''');
        break;
      default:
        print('Valeur inconnue');
        break;
    }
  } while (userChoice != 3);
}
